local M = {}

local scenarioController = require("scenario/gravitationalRacing/scenarioController")

local start, setup = false, false

local function onPreRender(dt)
  if setup then
    scenarioController.update(dt, start)
  end
end

local function begin()
  --[[
  Note: this function can be hooked and run from specific scenario script files
  to allow for earlier movement of celestials
  ]]--
  start = true
end

-- local function passiveCelestials()
--   --[[
--   Activates passive mode on celestials, disabling the visual for danger-zones
--   and prevents the player vehicle from being affected
--   ]]--
--   require("scenario/gravitationalRacing/celestial/celestialsHandler").enablePassiveMode()
-- end

local function onRaceStart()
  begin()
end

local function onScenarioChange(sc)
  if sc.state == "pre-running" then
    scenarioController.initialise(sc.sourceFile)

    --Hide the floor
    local ground = scenetree.findClassObjects('Groundplane')
    for _, name in ipairs(ground) do
      scenetree.findObject(name).hidden = true
    end

    setup = true
  end
end

M.onPreRender = onPreRender
M.begin = begin
M.passiveCelestials = passiveCelestials
M.onRaceStart = onRaceStart
M.onScenarioChange = onScenarioChange
return M
