local M = {}

local function difficultyToColour(difficulty)
  --[[
  Returns the colour of a difficulty
  ]]--
  difficulty = difficulty:upper()

  if difficulty == "TUTORIAL" then
    return "white"
  elseif difficulty == "SIMULATION" then
    return "lightblue"
  elseif difficulty == "BASIC" then
    return "lightgreen"
  elseif difficulty == "ADVANCED" then
    return "gold"
  elseif difficulty == "EXPERT" then
    return "red"
  elseif difficulty == "INSANE" then
    return "dodgerblue"
  end
end

local function getScenarioDetails(sourceFile)
  --[[
  Returns the title and difficulty of the scenario
  ]]--
  local scenarioTitle = jsonDecode(readFile(sourceFile), sourceFile)[1].name
  --Matches the first part of the title
  local scenarioName = scenarioTitle:match("[%a%s']*")
  scenarioName = scenarioName:sub(1, #scenarioName-1)
  --Matches the seconds part in the brackets
  local scenarioDifficulty = scenarioTitle:match("%((%a+)%)")

  return scenarioName, scenarioDifficulty
end

local function getSpecificDetail(attribute, sourceFile)
  return jsonDecode(readFile(sourceFile), sourceFile)[1][attribute]
end

M.difficultyToColour = difficultyToColour
M.getScenarioDetails = getScenarioDetails
M.getSpecificDetail = getSpecificDetail
return M
